package wanijo.wanijo2.domain

import org.springframework.data.annotation.Id
import org.springframework.data.jdbc.core.mapping.AggregateReference
import org.springframework.data.relational.core.mapping.Table
import org.springframework.data.repository.Repository
import java.time.ZonedDateTime

@Table("T_TAG")
data class Tag(
    @Id
    val id: Long = 0,
    val name: String,
    val createdAt: ZonedDateTime = ZonedDateTime.now()
)

@Table("T_DOCUMENT_TAGGING")
data class DocumentTagging(
    @Id
    val id: Long = 0,
    val tagId: AggregateReference<Tag, Long>,
    val documentId: AggregateReference<Document, Long>
)

interface DocumentTaggingDao : Repository<DocumentTagging, Long> {
    fun save(tagging: DocumentTagging)
}

interface TagDao: Repository<Tag, Long> {
    fun save(tag: Tag): Tag
    fun findByName(name: String): Tag?
    fun findAll(): List<Tag>
}
